#ifndef CAN_H
#define	CAN_H

#include <xc.h> 

static const uint8_t DLC_BYTES[16] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 12, 16, 20, 24, 32, 48, 64};

typedef struct{
    uint32_t ID;
    union{
        uint32_t status;
        struct{
            uint8_t DLC:4;
            uint8_t IDE:1;
            uint8_t RTR:1;
            uint8_t BRS:1;
            uint8_t FDF:1;
            uint8_t ESI:1;
            uint8_t _res2:2;
            uint8_t FILHIT:5;
            uint16_t _res3;
        };
    };
    union{
        uint8_t     Byte[64];
        int8_t      iByte[64];
        uint16_t    Word[32];
        int16_t     iWord[32];
        uint32_t    DWord[16];
        int32_t     iDWord[16];
    };
} CAN_MSG;


void CAN_Config(void);
uint8_t CAN1_Transmit(CAN_MSG *CanMsg);
uint8_t CAN1_Receive(CAN_MSG *CanMsg);

#endif

